# $Date: 1995/11/21 09:38:45 $ $Author: kg $ $Revision: 1.4 $ #

# kg, 09/12/93 #

#--
gcdlib::int_gcd -- compute the gcd of two polynomials over the integers

gcdlib::int_gcd(p1, p2)

p1,p2 - non-zero polynomials of type 'Expr' over the integers

gcdlib::int_gcd computes the gcd of 2 non-zero polynomials over the integers.
The arguments are not checked.
--#

gcdlib::int_gcd:= proc(a, b)
    local ca, cb, g;
begin
    # remove integer contents #
    ca:= icontent(a);
    cb:= icontent(b);
    a:= multcoeffs(a, 1/ca);
    b:= multcoeffs(b, 1/cb);
    ca:= igcd(ca, cb);
    
    if nops(op(a,2)) < 5 then
	# try heuristic and use sparse modular alg. if it fails #
	g:= gcdlib::heu_gcd(a, b);
	if domtype(g) <> DOM_POLY then
	    g:= gcdlib::int_mod_gcd(a, b)
	end_if;
    else
	g:= gcdlib::int_mod_gcd(a, b)
    end_if;
    
    # normalize result #
    if lcoeff(g) < 0 then
        multcoeffs(g, -ca/icontent(g))
    else
        multcoeffs(g, ca/icontent(g))
    end_if
end_proc:

# end of file #
