# hastype(x,t) checks if x contains a subexpression of type t
  hastype(x,{t1,t2,...}) checks if x contains a subexpression of type t1 or t2 or ...

  Examples:

  >> hastype(1+x,DOM_FLOAT);

                                   FALSE
  >> hastype(1.0+x,DOM_FLOAT);

                                   TRUE
  >> hastype(x+y,"_plus");

                                   TRUE
  
  >> hastype(x+y,{DOM_COMPLEX,DOM_RAT});

                                   FALSE
#

hastype := proc(_x_,_t_)
begin
   if type(_t_)<>DOM_SET then _t_:={_t_} end_if;
   maprec(_x_,_t_=fun((breakmap();genident())));
   bool(%<>_x_) 
end_proc:

Indets := proc(x,t) local s;
begin
   s:={};
   if type(t)<>DOM_SET then t:={t} end_if;
   maprec(x,t=fun((s:=s union {args(1)};args(1))));
   s
end_proc:
